## iOS Anywhere
A software on Raspberry Pi, to provide location simulation function to iOS device.
Tested on Raspberry Pi 2B (Ubuntu 20.04) + iPhone 7 (ios 13.3)

Version 20100111 vrqq.org

## How to depolyment?
**Copy DeveloperDiskImage.dmg and DeveloperDiskImage.dmg.signature to software_root/driver/version/**
Packaged in another file, source from */Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/DeviceSupport/* in Mac OS X with Xcode.app.
```bash
cp -Rf {somewhere}/13.2/* driver/13.2/
```
Note: iOS 13.3 please choose the developerDiskImage of 13.2

**Build**
```bash
g++ server.cpp mobile.cpp -o pi -lpthread -limobiledevice -DDIST
```

**Create a service and run it. (Ubuntu)**
```bash
cd /lib/systemd/system
sudo ln -s /home/ubuntu/iosanywhere.service
sudo systemctl enable iosanywhere
sudo service iosanywhere start
```

**Open usb hotspot network adapter (eth1, Ubuntu)**
```
# /etc/netplan/50-cloud-init.yaml
network:
    ethernets:
        eth0:
            dhcp4: true
            optional: true
        eth1:
            dhcp4: true
            optional: true
    version: 2
```

**(Optional) Grant privilege if run in non-root user**
```
# /etc/sysctl.conf
net.ipv4.ip_unprivileged_port_start = 80
```
Then ```sysctl --system``` to reload configuration, and ```./pi``` to run directly.

**Open in mobile phone**
* Connect iOS device to Pi with usb cable
* Open Hotspot on iOS
* Wait for Pi ready and you will see a blue hotspot hint bar on the top of screen
* Open http://your_host_name or http://172.20.10.3 (with default ip address assigned by DHCP)


## License
We use LGPL-3.0 to distribute this software.

* MIT License for cpp-httplib
* LGPL-2.1 License for libimobiledevice
* MIT license for jQuery
* Inspired by ios.location of LGPL-3.0 (https://github.com/FuHaoBlack/ios.location)

**DevDependence**
* jquery-3.4.1 (https://jquery.org/)
* libimobiledevice-dev 1.2.1~git20191129.9f79242-1 (https://github.com/libimobiledevice/libimobiledevice)
* cpp-httplib-0.5.1 (https://github.com/yhirose/cpp-httplib)
