// Copyright 2020 vrqq. (http://vrqq.org)

// This file is part of iOSAnywhere.

// iOSAnywhere is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// iOSAnywhere is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with iOSAnywhere.  If not, see <https://www.gnu.org/licenses/>.

#include <iostream>
#include <string>
#include "httplib.h"

using namespace std;

void init2();
std::string getUdid();
std::string getInjectLog();
void inject(std::string ver);
std::string locate(std::string lat1, std::string lng2);

int main() {
	init2();
	std::cout<<"[ios Anywhere] Starting server..."<<std::endl<<std::endl;
	using namespace httplib;
	Server svr;

	svr.Get("/api/inject", [](const Request &req, Response &resp) {
		std::string ver;
		for (auto it: req.params)
			if (it.first == "ver")
				ver = it.second;
		inject(ver);
		resp.set_content("", "text/plain");
	});

	svr.Get("/api/injectlog", [](const Request &req, Response &resp) {
		resp.set_content(getInjectLog(), "text/plain");
	});

	svr.Get("/api/locate", [](const Request &req, Response &resp) {
		std::string lat, lng;
		for (auto it: req.params) //req.params is multimap
			if (it.first == "lat")
				lat = it.second;
			else if (it.first == "lng")
				lng = it.second;
		// std::string txt = lat + ", " + lng;
		resp.set_content(locate(lat, lng), "text/plain");
	});

	svr.Get("/api/getudid", [](const Request &req, Response &resp) {
		resp.set_content(getUdid(), "text/plain");
	});

	svr.set_base_dir("./www");
	svr.listen("0.0.0.0", 8080);
	std::cout<<"[ios Anywhere] Exited."<<std::endl<<std::endl;
	return 0;
}
